<template>
    <div>
        <div>
            <span class="text-zinc-400 ml-1">Heure de fin</span>
            <input type="datetime-local" v-model="display_end_time" class="bg-zinc-950 w-full border-[1px] border-zinc-800 text-xl p-2 rounded-lg" @input="update_time"/>
        </div>

        <hr class="my-4">

        <div class="flex flex-col gap-2">
            <div class="flex items-center" v-for="player in game_state.players" :key="player.name">
               <span class="capitalize grow">{{ player.name }}</span>
                <input type="text" v-model="player.points" class="bg-zinc-950 w-16 border-[1px] border-zinc-800 text-xl p-2 rounded-lg" @input="update_player_points(player.name, $event.target.value)"/>
            </div>
            
        </div>
    </div>
</template>

<script setup lang="ts">
import { onMounted, ref } from 'vue';


const game_state = ref({players:[{name:"", points:0}], end_time: 0});
const WEBSOCKET_URL = "ws://127.0.0.1:3030/socket";

let ws = new WebSocket(WEBSOCKET_URL);
const display_end_time = ref("");

const update_time = function(event: any) {
    let time = event.target.value;

    let stamp = Date.parse(time).toString()


    ws.send(`set_end:${stamp.toString().slice(0,-3)}`);
}

const update_player_points = function(player: String, points: number) {
    ws.send(`set_points:${player}:${points}`);
}

onMounted(() => {


  ws.addEventListener("message", (event) => {
    console.log(event)


    let parseable = event.data.split(/:(.*)/s)
  

    switch (parseable[0]) {
      case "state":
        let buffer = JSON.parse(parseable[1]);

        // buffer.players = (buffer.players as Array<any>).sort((a, b) => 
        //   a.points > b.points ? -1 : 1
        // )

        game_state.value = buffer;
        display_end_time.value = new Date((buffer.end_time + 3600) * 1000).toISOString().slice(0, -1);
    }
  })


  ws.addEventListener("open", () => {
    ws.send("get_state");
  })
})

// ws.send("get_state");
</script>